;; test: val x val -> bool
(define test equal?)
  
;; personas y sus operaciones
(define (person name phone) (cons name phone))
(define (person-name p) (car p))
(define (person-phone p) (cdr p))

;; tests
(test (person-name (person "juan" 1234)) "juan")
(test (person-phone (person "juan" 1234)) 1234)

;; libreta y sus operaciones
(define (book) '())
;; takes a person and a book and returns the extended book
(define (add-person p b) (cons p b))

;; in-book?: name x book -> bool
;; returns true if there exists a person in book with name
;; #f otherwise
(define (in-book? name b) 
  (if (null? b) #f
      (if (equal? name (person-name (car b)))
          #t
          (in-book? name (cdr b)))))

;; looks for the phone number of name, and returns #f if not found
(define (get-phone name b) 
  (if (null? b) #f
      (if (equal? (person-name (car b)) name) 
          (person-phone (car b))
          (get-phone name (cdr b)))))

;; abstraccion: factorizar la "accion que tomar en caso de exito"
;; lookup: (person -> val) -> name x book -> val
(define (lookup succ)
  (letrec ((fun (lambda (name b)
               (if (null? b) #f
                   (if (equal? (person-name (car b)) name) 
                       (succ (car b))
                       (fun name (cdr b)))))))
    fun))

;; usando la abstraccion para redefinir get-phone y in-book?
(define get-phone (lookup person-phone))
(define in-book? (lookup (lambda (p) #t)))

;;tests
(define juan (person "juan" 1234))
(define test-book (add-person juan (book)))

(test (in-book? "juan" test-book) #t)
(test (in-book? "pedro" test-book) #f)
(test (get-phone "juan" test-book) 1234)
(test (get-phone "pedro" test-book) #f)

;; ahora, experimente con diferentes formas de abstraer el proceso de lookup
;; eg. (define (lookup succ name b) ...) 
;; -> defina get-phone and in-book? usando esa nueva abstraccion